<?php
namespace Neklo\Scheduler\Model;

use Magento\Framework\Model\AbstractModel;
use Magento\Framework\DataObject\IdentityInterface;
use Neklo\Scheduler\Api\Data\JobInterface;
use Neklo\Scheduler\Model\ResourceModel\Schedule\CollectionFactory;
use Magento\Framework\Model\ResourceModel\AbstractResource;
use Magento\Framework\Data\Collection\AbstractDb;

class Job  extends AbstractModel implements IdentityInterface, JobInterface
{
    const CACHE_TAG = 'neklo_cronjob';
    protected $_eventPrefix = 'neklo_cronjob';
    /**
     *
     * @var \Neklo\Scheduler\Model\ResourceModel\Schedule\CollectionFactory
     */
    protected $scheduleColFactory;

//    public function __construct(
//        \Magento\Framework\Model\Context $context,
//        \Magento\Framework\Registry $registry,
//        CollectionFactory $scheduleColFactory,
//        AbstractResource $resource = null,
//        AbstractDb $resourceCollection = null,
//        array $data = []
//    ) {
//        parent::__construct($context, $registry, $resource,
//            $resourceCollection, $data);
//        $this->scheduleColFactory = $scheduleColFactory;
//    }

    /**
     * Define resource model
     */
    protected function _construct()
    {
          $this->_init('Neklo\Scheduler\Model\ResourceModel\Job');
    }

    public function disable()
    {
        $this->setData(JobInterface::JOB_ENABLED, false);
        return $this;
    }

    public function enable()
    {
        $this->setData(JobInterface::JOB_ENABLED, true);
        return $this;
    }

    public function isEnabled()
    {
        return $this->getData(JobInterface::JOB_ENABLED);
    }

    /**
     * Get identities
     *
     * @return array
     */
    public function getIdentities()
    {
        $identities = [self::CACHE_TAG . '_' . $this->getId()];
        return $identities;
    }

    protected $schedules;
    public function getSchedules()
    {
        if (!$this->schedules) {
            /* @var $schedule \Neklo\Scheduler\Model\ResourceModel\Schedule\Collection */
            $schedule = $this->getResourceCollection();
//            $schedule->addFieldToFilter();
            $this->schedules = $schedule;
        }
        return $this->schedules;
    }
}
